#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <pthread.h>
#include "glovedata.h"

#define DEVNAME "/dev/pglove0"

int fd=0;
pthread_t rthread;
void* get_glove_data(void*);

int main(int argc, char** argv)
{
  int status=0;

  if((fd=open(DEVNAME, O_RDONLY)) < 0)
  {
    printf("can't open, %d\n", fd);
    exit(1);
  }

  status=pthread_create(&rthread, NULL, get_glove_data, NULL);
  if(status==-1)
  {
    printf("error creating midi thread\n");
    exit(1);
  }

  printf("fd=%d\n",fd);

  while(1) {}

  close(fd);
  return 0;
}

void* get_glove_data(void* x)
{
  char buf[12]={0};
  glove_data* data=(glove_data*)buf;

  while(1)
  {
    read(fd, buf, sizeof(buf));
    printf("%2.2x %+4i %+4i %+4i ", data->status, data->x, data->y, data->z);
    printf("%2.2x %2.2x %2.2x ", data->rot, data->fingers, data->keys);
    printf("%2.2x %2.2x %2.2x %2.2x %2.2x\n", data->dummy7, data->dummy8, data->dummy9, data->dummy10, data->dummy11);
    usleep(10100);
  }
}
